"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
require("@nomicfoundation/hardhat-chai-matchers");
require("@nomicfoundation/hardhat-network-helpers");
require("@nomiclabs/hardhat-ethers");
require("@nomiclabs/hardhat-etherscan");
require("@typechain/hardhat");
require("hardhat-gas-reporter");
require("solidity-coverage");
/**
 * If a new official plugin is added, make sure to update:
 *   - The tsconfig.json file
 *   - The hardhat-toolbox GitHub workflow
 *   - The parts of the documentation that install hardhat-toolbox with npm 6 or yarn
 *   - The list of dependencies that the sample projects install
 *   - The README
 */
const config_1 = require("hardhat/config");
(0, config_1.extendConfig)((config, userConfig) => {
    var _a;
    const configAsAny = config;
    // hardhat-gas-reporter doesn't use extendConfig, so
    // config.gasReporter === userConfig.gasReporter
    // we use userConfig.gasReporter here for the types
    const gasReporterConfig = userConfig.gasReporter;
    configAsAny.gasReporter = gasReporterConfig !== null && gasReporterConfig !== void 0 ? gasReporterConfig : {};
    if ((gasReporterConfig === null || gasReporterConfig === void 0 ? void 0 : gasReporterConfig.enabled) === undefined) {
        // eslint-disable-next-line @typescript-eslint/strict-boolean-expressions
        configAsAny.gasReporter.enabled = process.env.REPORT_GAS ? true : false;
    }
    if ((gasReporterConfig === null || gasReporterConfig === void 0 ? void 0 : gasReporterConfig.currency) === undefined) {
        configAsAny.gasReporter.currency = "USD";
    }
    // We don't generate types for js projects
    if (((_a = userConfig === null || userConfig === void 0 ? void 0 : userConfig.typechain) === null || _a === void 0 ? void 0 : _a.dontOverrideCompile) === undefined) {
        config.typechain.dontOverrideCompile =
            config.paths.configFile.endsWith(".js");
    }
});
//# sourceMappingURL=index.js.map